﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;

namespace ActiveReports_Dynamics_Columns_PageReport
{
    public partial class Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected void btnRun_Click(object sender, EventArgs e)
        {
            // 加载报表
            LoadReport();
        }

        // 加载报表
        private void LoadReport()
        {
            GrapeCity.ActiveReports.PageReport report1 = new GrapeCity.ActiveReports.PageReport(new System.IO.FileInfo(Server.MapPath("PageReport1.rdlx")));

            // 只显示选中的列，未选中列不出现在报表中
            SetSelectedColumns(report1);

            report1.Report.DataSources[0].ConnectionProperties.ConnectString = "provider=Microsoft.Jet.OLEDB.4.0;data source=" + Server.MapPath("App_Data\\NWind_CHS.mdb");

            WebViewer1.Report = report1;
        }

        // 设置表格中列的显示状态
        private void SetSelectedColumns(GrapeCity.ActiveReports.PageReport report)
        {
            foreach (ListItem item in cblColumns.Items)
            {
                SetSelectedColumn(report, item.Text, item.Selected);
            }
        }

        // 设置单列的显示状态
        private void SetSelectedColumn(GrapeCity.ActiveReports.PageReport report, string columnname, bool hidden)
        {
            string datafield = "";
            GrapeCity.ActiveReports.PageReportModel.Table table = report.Report.Body.ReportItems[0] as GrapeCity.ActiveReports.PageReportModel.Table;
            for (int i = 0; i < table.TableColumns.Count; i++)
            {
                datafield = (table.Header.TableRows[1].TableCells[i].ReportItems[0] as GrapeCity.ActiveReports.PageReportModel.TextBox).Value.ToString();

                if (string.Equals(datafield, columnname))
                {
                    table.TableColumns[i].Visibility.Hidden = (!hidden).ToString();
                    return;
                }
            }
        }

    }
}